package sunflowtest;

import java.awt.Color;
import java.awt.geom.Point2D;

import processing.core.PApplet;

import sunflowapiapi.P5SunflowAPIAPI;
import org.sunflow.math.Point3;
import org.sunflow.math.Vector3;

public class SunFlowTest extends PApplet {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	
	int sceneWidth = 640;
	int sceneHeight = 480;
	P5SunflowAPIAPI sunflow;
	
	public void setup() {
		size(sceneWidth, sceneHeight, "sunflowapiapi.P5SunflowAPIAPI");
		sunflow = (P5SunflowAPIAPI) g;
	}
	
	float count = 0f;
	float maxCount = 300f;
	
	public void draw() {
		int samples = 32;
		sunflow.setWidth(sceneWidth);
		sunflow.setHeight(sceneHeight);
		sunflow.setBackground(255, 255, 255);
		sunflow.setSunSkyLight("sunny");
		sunflow.setPointLight("myPointLight", new Point3(0f,5f,5f), new Color(255,255,255));
		sunflow.setDirectionalLight("myDirectionalLight", new Point3(-2f,3f,0f), new Vector3(0f,0f,0f), 3f, new Color(1f,0f,0f));

		sunflow.setThinlensCamera("thinLensCamera", 50f, (float)sceneWidth/sceneHeight);
		sunflow.setAmbientOcclusionShader(new Color(255,255,255), new Color(0,0,0), samples, 1f);
		sunflow.drawPlane("ground", new Point3(0f,-1.4f,0f), new Vector3(0f,1f,0f));
		sunflow.setAmbientOcclusionShader(new Color(255,255,255), new Color(255,255,255), samples, 1f);
		sunflow.drawPlane("back", new Point3(0,0,-100f), new Vector3(0,0,1));
		
		sunflow.setShinyDiffuseShader(new Color(30,30,30), 10f);
		float hairPoints[] = {	0.0f, 0.0f, 0.0f, 
								1.0f, 0.5f, 0.0f,
								-1.0f, 1.0f, 0.0f,
								0.0f, 1.5f, 0.0f };
		float hairWidths[] = {0.1f};
		sunflow.drawHair("hair", 3, hairPoints, hairWidths);
		
		sunflow.setPathTracingGIEngine(samples);
		sunflow.render("SunflowTestRender_box_"+round(count)+".png");  //+year()+"-"+month()+"-"+day()+"_"+hour()+"-"+minute()+"-"+second()+".png"); 
		count++;
		
		//if(count>maxCount){
			exit();
		//}
	}
	
	public void mouseReleased() {
	}

	public void keyPressed() {
	}
	
	public static void main(String _args[]) {
		PApplet.main(new String[] { sunflowtest.SunFlowTest.class.getName() });
	}
}
